Index: trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachineLogic.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachineLogic.cpp	(revision 98418)
+++ trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachineLogic.cpp	(revision 98419)
@@ -422,24 +422,24 @@
 void UIMachineLogic::sltChangeVisualStateToNormal()
 {
-    uisession()->setRequestedVisualState(UIVisualStateType_Invalid);
-    uisession()->changeVisualState(UIVisualStateType_Normal);
+    uimachine()->setRequestedVisualState(UIVisualStateType_Invalid);
+    uimachine()->asyncChangeVisualState(UIVisualStateType_Normal);
 }
 
 void UIMachineLogic::sltChangeVisualStateToFullscreen()
 {
-    uisession()->setRequestedVisualState(UIVisualStateType_Invalid);
-    uisession()->changeVisualState(UIVisualStateType_Fullscreen);
+    uimachine()->setRequestedVisualState(UIVisualStateType_Invalid);
+    uimachine()->asyncChangeVisualState(UIVisualStateType_Fullscreen);
 }
 
 void UIMachineLogic::sltChangeVisualStateToSeamless()
 {
-    uisession()->setRequestedVisualState(UIVisualStateType_Invalid);
-    uisession()->changeVisualState(UIVisualStateType_Seamless);
+    uimachine()->setRequestedVisualState(UIVisualStateType_Invalid);
+    uimachine()->asyncChangeVisualState(UIVisualStateType_Seamless);
 }
 
 void UIMachineLogic::sltChangeVisualStateToScale()
 {
-    uisession()->setRequestedVisualState(UIVisualStateType_Invalid);
-    uisession()->changeVisualState(UIVisualStateType_Scale);
+    uimachine()->setRequestedVisualState(UIVisualStateType_Invalid);
+    uimachine()->asyncChangeVisualState(UIVisualStateType_Scale);
 }
 
@@ -585,5 +585,5 @@
     /* Update action states: */
     LogRel3(("GUI: UIMachineLogic::sltAdditionsStateChanged: Adjusting actions availability according to GA state.\n"));
-    actionPool()->action(UIActionIndexRT_M_View_T_Seamless)->setEnabled(uisession()->isVisualStateAllowed(UIVisualStateType_Seamless) &&
+    actionPool()->action(UIActionIndexRT_M_View_T_Seamless)->setEnabled(uimachine()->isVisualStateAllowed(UIVisualStateType_Seamless) &&
                                                                         uisession()->isGuestSupportsSeamless());
 }
@@ -2706,5 +2706,5 @@
      * but is not entered because we're waiting for a guest addition permission. */
     if (   visualStateType() != enmRequestedState
-        && uisession()->requestedVisualState() != enmRequestedState)
+        && uimachine()->requestedVisualState() != enmRequestedState)
     {
         switch (enmRequestedState)
Index: trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachineWindow.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachineWindow.cpp	(revision 98418)
+++ trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachineWindow.cpp	(revision 98419)
@@ -687,6 +687,6 @@
                 {
                     /* Enter 'full-screen' mode: */
-                    uisession()->setRequestedVisualState(UIVisualStateType_Invalid);
-                    uisession()->changeVisualState(UIVisualStateType_Fullscreen);
+                    uimachine()->setRequestedVisualState(UIVisualStateType_Invalid);
+                    uimachine()->asyncChangeVisualState(UIVisualStateType_Fullscreen);
                 }
             }
Index: trunk/src/VBox/Frontends/VirtualBox/src/runtime/UISession.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/runtime/UISession.cpp	(revision 98418)
+++ trunk/src/VBox/Frontends/VirtualBox/src/runtime/UISession.cpp	(revision 98419)
@@ -265,24 +265,4 @@
 {
     return machineLogic() ? machineLogic()->activeMachineWindow() : 0;
-}
-
-bool UISession::isVisualStateAllowed(UIVisualStateType state) const
-{
-    return uimachine()->isVisualStateAllowed(state);
-}
-
-void UISession::changeVisualState(UIVisualStateType visualStateType)
-{
-    uimachine()->asyncChangeVisualState(visualStateType);
-}
-
-void UISession::setRequestedVisualState(UIVisualStateType visualStateType)
-{
-    uimachine()->setRequestedVisualState(visualStateType);
-}
-
-UIVisualStateType UISession::requestedVisualState() const
-{
-    return uimachine()->requestedVisualState();
 }
 
Index: trunk/src/VBox/Frontends/VirtualBox/src/runtime/UISession.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/runtime/UISession.h	(revision 98418)
+++ trunk/src/VBox/Frontends/VirtualBox/src/runtime/UISession.h	(revision 98419)
@@ -176,13 +176,4 @@
     UIMachineWindow *activeMachineWindow() const;
 
-    /** Returns whether visual @a state is allowed. */
-    bool isVisualStateAllowed(UIVisualStateType state) const;
-    /** Requests visual-state change. */
-    void changeVisualState(UIVisualStateType visualStateType);
-    /** Requests visual-state to be entered when possible. */
-    void setRequestedVisualState(UIVisualStateType visualStateType);
-    /** Returns requested visual-state to be entered when possible. */
-    UIVisualStateType requestedVisualState() const;
-
     bool isSaved() const { return machineState() == KMachineState_Saved ||
                                   machineState() == KMachineState_AbortedSaved; }
Index: trunk/src/VBox/Frontends/VirtualBox/src/runtime/fullscreen/UIMachineLogicFullscreen.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/runtime/fullscreen/UIMachineLogicFullscreen.cpp	(revision 98418)
+++ trunk/src/VBox/Frontends/VirtualBox/src/runtime/fullscreen/UIMachineLogicFullscreen.cpp	(revision 98419)
@@ -246,9 +246,9 @@
 
             /* Change visual-state to requested: */
-            UIVisualStateType type = uisession()->requestedVisualState();
+            UIVisualStateType type = uimachine()->requestedVisualState();
             if (type == UIVisualStateType_Invalid)
                 type = UIVisualStateType_Normal;
-            uisession()->setRequestedVisualState(UIVisualStateType_Invalid);
-            uisession()->changeVisualState(type);
+            uimachine()->setRequestedVisualState(UIVisualStateType_Invalid);
+            uimachine()->asyncChangeVisualState(type);
         }
     }
@@ -286,5 +286,5 @@
 
         /* Ask session to change 'fullscreen' mode to 'normal': */
-        uisession()->setRequestedVisualState(UIVisualStateType_Normal);
+        uimachine()->setRequestedVisualState(UIVisualStateType_Normal);
 
         /* If session already initialized => push mode-change directly: */
@@ -303,5 +303,5 @@
     {
         /* Request 'normal' (window) visual-state: */
-        uisession()->setRequestedVisualState(UIVisualStateType_Normal);
+        uimachine()->setRequestedVisualState(UIVisualStateType_Normal);
         /* Ask window(s) to exit 'fullscreen' mode: */
         emit sigNotifyAboutNativeFullscreenShouldBeExited();
@@ -318,5 +318,5 @@
     {
         /* Request 'seamless' visual-state: */
-        uisession()->setRequestedVisualState(UIVisualStateType_Seamless);
+        uimachine()->setRequestedVisualState(UIVisualStateType_Seamless);
         /* Ask window(s) to exit 'fullscreen' mode: */
         emit sigNotifyAboutNativeFullscreenShouldBeExited();
@@ -333,5 +333,5 @@
     {
         /* Request 'scale' visual-state: */
-        uisession()->setRequestedVisualState(UIVisualStateType_Scale);
+        uimachine()->setRequestedVisualState(UIVisualStateType_Scale);
         /* Ask window(s) to exit 'fullscreen' mode: */
         emit sigNotifyAboutNativeFullscreenShouldBeExited();
@@ -342,5 +342,5 @@
 {
     LogRel(("GUI: UIMachineLogicFullscreen::sltCheckForRequestedVisualStateType: Requested-state=%d, Machine-state=%d\n",
-            uisession()->requestedVisualState(), uisession()->machineState()));
+            uimachine()->requestedVisualState(), uisession()->machineState()));
 
     /* Do not try to change visual-state type if machine was not started yet: */
@@ -353,5 +353,5 @@
 
     /* Check requested visual-state types: */
-    switch (uisession()->requestedVisualState())
+    switch (uimachine()->requestedVisualState())
     {
         /* If 'normal' visual-state type is requested: */
@@ -360,6 +360,6 @@
             LogRel(("GUI: UIMachineLogicFullscreen::sltCheckForRequestedVisualStateType: "
                     "Going 'normal' as requested...\n"));
-            uisession()->setRequestedVisualState(UIVisualStateType_Invalid);
-            uisession()->changeVisualState(UIVisualStateType_Normal);
+            uimachine()->setRequestedVisualState(UIVisualStateType_Invalid);
+            uimachine()->asyncChangeVisualState(UIVisualStateType_Normal);
             break;
         }
Index: trunk/src/VBox/Frontends/VirtualBox/src/runtime/normal/UIMachineLogicNormal.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/runtime/normal/UIMachineLogicNormal.cpp	(revision 98418)
+++ trunk/src/VBox/Frontends/VirtualBox/src/runtime/normal/UIMachineLogicNormal.cpp	(revision 98419)
@@ -73,5 +73,5 @@
 {
     LogRel(("GUI: UIMachineLogicNormal::sltCheckForRequestedVisualStateType: Requested-state=%d, Machine-state=%d\n",
-            uisession()->requestedVisualState(), uisession()->machineState()));
+            uimachine()->requestedVisualState(), uisession()->machineState()));
 
     /* Do not try to change visual-state type if machine was not started yet: */
@@ -84,5 +84,5 @@
 
     /* Check requested visual-state types: */
-    switch (uisession()->requestedVisualState())
+    switch (uimachine()->requestedVisualState())
     {
         /* If 'seamless' visual-state type is requested: */
@@ -94,6 +94,6 @@
                 LogRel(("GUI: UIMachineLogicNormal::sltCheckForRequestedVisualStateType: "
                         "Going 'seamless' as requested...\n"));
-                uisession()->setRequestedVisualState(UIVisualStateType_Invalid);
-                uisession()->changeVisualState(UIVisualStateType_Seamless);
+                uimachine()->setRequestedVisualState(UIVisualStateType_Invalid);
+                uimachine()->asyncChangeVisualState(UIVisualStateType_Seamless);
             }
             else
Index: trunk/src/VBox/Frontends/VirtualBox/src/runtime/normal/UIMachineViewNormal.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/runtime/normal/UIMachineViewNormal.cpp	(revision 98418)
+++ trunk/src/VBox/Frontends/VirtualBox/src/runtime/normal/UIMachineViewNormal.cpp	(revision 98419)
@@ -150,5 +150,5 @@
 {
     /* Skip if another visual representation mode requested: */
-    if (uisession()->requestedVisualState() == UIVisualStateType_Seamless) // Seamless only for now.
+    if (uimachine()->requestedVisualState() == UIVisualStateType_Seamless) // Seamless only for now.
         return;
 
Index: trunk/src/VBox/Frontends/VirtualBox/src/runtime/scale/UIMachineLogicScale.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/runtime/scale/UIMachineLogicScale.cpp	(revision 98418)
+++ trunk/src/VBox/Frontends/VirtualBox/src/runtime/scale/UIMachineLogicScale.cpp	(revision 98419)
@@ -39,5 +39,4 @@
 #include "UIMachineWindow.h"
 #include "UIMessageCenter.h"
-#include "UISession.h"
 #include "UIShortcutPool.h"
 #ifndef VBOX_WS_MAC
Index: trunk/src/VBox/Frontends/VirtualBox/src/runtime/scale/UIMachineViewScale.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/runtime/scale/UIMachineViewScale.cpp	(revision 98418)
+++ trunk/src/VBox/Frontends/VirtualBox/src/runtime/scale/UIMachineViewScale.cpp	(revision 98419)
@@ -39,5 +39,4 @@
 #include "UIMachineViewScale.h"
 #include "UIMachineWindow.h"
-#include "UISession.h"
 
 /* COM includes: */
Index: trunk/src/VBox/Frontends/VirtualBox/src/runtime/scale/UIMachineWindowScale.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/runtime/scale/UIMachineWindowScale.cpp	(revision 98418)
+++ trunk/src/VBox/Frontends/VirtualBox/src/runtime/scale/UIMachineWindowScale.cpp	(revision 98419)
@@ -44,5 +44,4 @@
 #include "UIMachineView.h"
 #include "UINotificationCenter.h"
-#include "UISession.h"
 #ifdef VBOX_WS_MAC
 # include "VBoxUtils.h"
Index: trunk/src/VBox/Frontends/VirtualBox/src/runtime/seamless/UIMachineLogicSeamless.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/runtime/seamless/UIMachineLogicSeamless.cpp	(revision 98418)
+++ trunk/src/VBox/Frontends/VirtualBox/src/runtime/seamless/UIMachineLogicSeamless.cpp	(revision 98419)
@@ -118,5 +118,5 @@
 {
     LogRel(("GUI: UIMachineLogicSeamless::sltCheckForRequestedVisualStateType: Requested-state=%d, Machine-state=%d\n",
-            uisession()->requestedVisualState(), uisession()->machineState()));
+            uimachine()->requestedVisualState(), uisession()->machineState()));
 
     /* Do not try to change visual-state type if machine was not started yet: */
@@ -133,6 +133,6 @@
         LogRel(("GUI: UIMachineLogicSeamless::sltCheckForRequestedVisualStateType: "
                 "Leaving 'seamless' as it is no more supported...\n"));
-        uisession()->setRequestedVisualState(UIVisualStateType_Seamless);
-        uisession()->changeVisualState(UIVisualStateType_Normal);
+        uimachine()->setRequestedVisualState(UIVisualStateType_Seamless);
+        uimachine()->asyncChangeVisualState(UIVisualStateType_Normal);
     }
 }
Index: trunk/src/VBox/Frontends/VirtualBox/src/runtime/seamless/UIMachineWindowSeamless.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/runtime/seamless/UIMachineWindowSeamless.cpp	(revision 98418)
+++ trunk/src/VBox/Frontends/VirtualBox/src/runtime/seamless/UIMachineWindowSeamless.cpp	(revision 98419)
@@ -40,5 +40,4 @@
 #include "UIMachineView.h"
 #include "UIMachineWindowSeamless.h"
-#include "UISession.h"
 #if   defined(VBOX_WS_WIN) || defined(VBOX_WS_X11)
 # include "UIMachineDefs.h"