Index: /trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIIndicatorsPool.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIIndicatorsPool.cpp	(revision 98423)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIIndicatorsPool.cpp	(revision 98424)
@@ -1102,5 +1102,5 @@
 
         /* VT-x/AMD-V feature: */
-        KVMExecutionEngine enmEngine = m_pSession->getVMExecutionEngine();
+        KVMExecutionEngine enmEngine = m_pMachine->vmExecutionEngine();
         QString strExecutionEngine;
         switch (enmEngine)
@@ -1125,10 +1125,10 @@
 
         /* Nested Paging feature: */
-        const QString strNestedPaging = m_pSession->isHWVirtExNestedPagingEnabled() ?
+        const QString strNestedPaging = m_pMachine->isHWVirtExNestedPagingEnabled() ?
                                         UICommon::tr("Active", "details report (Nested Paging)") :
                                         UICommon::tr("Inactive", "details report (Nested Paging)");
 
         /* Unrestricted Execution feature: */
-        const QString strUnrestrictExec = m_pSession->isHWVirtExUXEnabled() ?
+        const QString strUnrestrictExec = m_pMachine->isHWVirtExUXEnabled() ?
                                           UICommon::tr("Active", "details report (Unrestricted Execution)") :
                                           UICommon::tr("Inactive", "details report (Unrestricted Execution)");
@@ -1138,5 +1138,5 @@
 
         /* Paravirtualization feature: */
-        const QString strParavirt = gpConverter->toString(m_pSession->paraVirtProvider());
+        const QString strParavirt = gpConverter->toString(m_pMachine->paravirtProvider());
 
         /* Prepare tool-tip: */
Index: /trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachine.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachine.cpp	(revision 98423)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachine.cpp	(revision 98424)
@@ -836,4 +836,8 @@
     , m_fIsMouseIntegrated(true)
     , m_iMouseState(0)
+    , m_enmVMExecutionEngine(KVMExecutionEngine_NotSet)
+    , m_fIsHWVirtExNestedPagingEnabled(false)
+    , m_fIsHWVirtExUXEnabled(false)
+    , m_enmParavirtProvider(KParavirtProvider_None)
     , m_fIsManualOverride(false)
     , m_defaultCloseAction(MachineCloseAction_Invalid)
@@ -873,4 +877,5 @@
 
     /* Update stuff which doesn't send events on init: */
+    updateVirtualizationState();
     updateStateAudioActions();
     updateMouseState();
@@ -1704,2 +1709,10 @@
 }
 #endif /* VBOX_WS_WIN */
+
+void UIMachine::updateVirtualizationState()
+{
+    m_enmVMExecutionEngine = uisession()->debugger().GetExecutionEngine();
+    m_fIsHWVirtExNestedPagingEnabled = uisession()->debugger().GetHWVirtExNestedPagingEnabled();
+    m_fIsHWVirtExUXEnabled = uisession()->debugger().GetHWVirtExUXEnabled();
+    m_enmParavirtProvider = uisession()->machine().GetEffectiveParavirtProvider();
+}
Index: /trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachine.h
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachine.h	(revision 98423)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachine.h	(revision 98424)
@@ -308,4 +308,18 @@
     /** @} */
 
+    /** @name Virtualization stuff.
+     ** @{ */
+        /** Returns IMachineDebugger::ExecutionEngine reference. */
+        KVMExecutionEngine vmExecutionEngine() const { return m_enmVMExecutionEngine; }
+
+        /** Returns whether nested-paging CPU hardware virtualization extension is enabled. */
+        bool isHWVirtExNestedPagingEnabled() const { return m_fIsHWVirtExNestedPagingEnabled; }
+        /** Returns whether the VM is currently making use of the unrestricted execution feature of VT-x. */
+        bool isHWVirtExUXEnabled() const { return m_fIsHWVirtExUXEnabled; }
+
+        /** Returns VM's effective paravirtualization provider. */
+        KParavirtProvider paravirtProvider() const { return m_enmParavirtProvider; }
+    /** @} */
+
     /** @name Close stuff.
      * @{ */
@@ -544,4 +558,10 @@
     /** @} */
 
+    /** @name Virtualization stuff.
+     ** @{ */
+        /** Updates virtualization state. */
+        void updateVirtualizationState();
+    /** @} */
+
     /** Holds the static instance. */
     static UIMachine *s_pInstance;
@@ -672,4 +692,18 @@
     /** @} */
 
+    /** @name Virtualization stuff.
+     ** @{ */
+        /** Holds the IMachineDebugger::ExecutionEngine reference. */
+        KVMExecutionEngine  m_enmVMExecutionEngine;
+
+        /** Holds whether nested-paging CPU hardware virtualization extension is enabled. */
+        bool  m_fIsHWVirtExNestedPagingEnabled;
+        /** Holds whether the VM is currently making use of the unrestricted execution feature of VT-x. */
+        bool  m_fIsHWVirtExUXEnabled;
+
+        /** Holds the VM's effective paravirtualization provider. */
+        KParavirtProvider  m_enmParavirtProvider;
+    /** @} */
+
     /** @name Close stuff.
      * @{ */
Index: /trunk/src/VBox/Frontends/VirtualBox/src/runtime/UISession.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/runtime/UISession.cpp	(revision 98423)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/runtime/UISession.cpp	(revision 98424)
@@ -169,7 +169,4 @@
     machineLogic()->initializePostPowerUp();
 
-    /* Load VM settings: */
-    loadVMSettings();
-
 #ifdef VBOX_GUI_WITH_PIDFILE
     uiCommon().createPidfile();
@@ -378,10 +375,4 @@
     , m_fIsGuestSupportsGraphics(false)
     , m_fIsGuestSupportsSeamless(false)
-    /* CPU hardware virtualization features for VM: */
-    , m_enmVMExecutionEngine(KVMExecutionEngine_NotSet)
-    , m_fIsHWVirtExNestedPagingEnabled(false)
-    , m_fIsHWVirtExUXEnabled(false)
-    /* VM's effective paravirtualization provider: */
-    , m_paraVirtProvider(KParavirtProvider_None)
 {
 }
@@ -849,16 +840,4 @@
 }
 
-void UISession::loadVMSettings()
-{
-    /* Cache IMachine::ExecutionEngine value. */
-    m_enmVMExecutionEngine = m_debugger.GetExecutionEngine();
-    /* Load nested-paging CPU hardware virtualization extension: */
-    m_fIsHWVirtExNestedPagingEnabled = m_debugger.GetHWVirtExNestedPagingEnabled();
-    /* Load whether the VM is currently making use of the unrestricted execution feature of VT-x: */
-    m_fIsHWVirtExUXEnabled = m_debugger.GetHWVirtExUXEnabled();
-    /* Load VM's effective paravirtualization provider: */
-    m_paraVirtProvider = m_machine.GetEffectiveParavirtProvider();
-}
-
 UIFrameBuffer* UISession::frameBuffer(ulong uScreenId) const
 {
Index: /trunk/src/VBox/Frontends/VirtualBox/src/runtime/UISession.h
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/runtime/UISession.h	(revision 98423)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/runtime/UISession.h	(revision 98424)
@@ -224,17 +224,4 @@
     const QVector<UIFrameBuffer*>& frameBuffers() const { return m_frameBufferVector; }
 
-    /** @name CPU hardware virtualization features for VM.
-     ** @{ */
-    /** Returns whether CPU hardware virtualization extension is enabled. */
-    KVMExecutionEngine getVMExecutionEngine() const { return m_enmVMExecutionEngine; }
-    /** Returns whether nested-paging CPU hardware virtualization extension is enabled. */
-    bool isHWVirtExNestedPagingEnabled() const { return m_fIsHWVirtExNestedPagingEnabled; }
-    /** Returns whether the VM is currently making use of the unrestricted execution feature of VT-x. */
-    bool isHWVirtExUXEnabled() const { return m_fIsHWVirtExUXEnabled; }
-    /** @} */
-
-    /** Returns VM's effective paravirtualization provider. */
-    KParavirtProvider paraVirtProvider() const { return m_paraVirtProvider; }
-
     /** Returns a vector of media attached to the machine. */
     CMediumVector machineMedia() const;
@@ -297,6 +284,4 @@
     bool preprocessInitialization();
     bool mountAdHocImage(KDeviceType enmDeviceType, UIMediumDeviceType enmMediumType, const QString &strMediumName);
-    /** Loads VM settings. */
-    void loadVMSettings();
 
     /* Private variables: */
@@ -341,18 +326,4 @@
     bool  m_fIsGuestSupportsGraphics : 1;
     bool  m_fIsGuestSupportsSeamless : 1;
-
-    /** Copy of IMachineDebugger::ExecutionEngine */
-    KVMExecutionEngine m_enmVMExecutionEngine;
-
-    /** @name CPU hardware virtualization features for VM.
-     ** @{ */
-    /** Holds whether nested-paging CPU hardware virtualization extension is enabled. */
-    bool m_fIsHWVirtExNestedPagingEnabled;
-    /** Holds whether the VM is currently making use of the unrestricted execution feature of VT-x. */
-    bool m_fIsHWVirtExUXEnabled;
-    /** @} */
-
-    /** Holds VM's effective paravirtualization provider. */
-    KParavirtProvider m_paraVirtProvider;
 };
 