Index: /trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIIndicatorsPool.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIIndicatorsPool.cpp	(revision 98490)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIIndicatorsPool.cpp	(revision 98491)
@@ -44,5 +44,4 @@
 #include "UIIndicatorsPool.h"
 #include "UIMachine.h"
-#include "UISession.h"
 
 
@@ -55,5 +54,5 @@
 
     /** Constructor which remembers passed @a session object. */
-    UISessionStateStatusBarIndicator(IndicatorType enmType, UIMachine *pMachine, UISession *pSession);
+    UISessionStateStatusBarIndicator(IndicatorType enmType, UIMachine *pMachine);
 
     /** Returns the indicator type. */
@@ -76,6 +75,4 @@
     /** Holds the machine UI reference. */
     UIMachine *m_pMachine;
-    /** Holds the session UI reference. */
-    UISession *m_pSession;
 
     /** Holds the indicator description. */
@@ -145,8 +142,7 @@
 
 
-UISessionStateStatusBarIndicator::UISessionStateStatusBarIndicator(IndicatorType enmType, UIMachine *pMachine, UISession *pSession)
+UISessionStateStatusBarIndicator::UISessionStateStatusBarIndicator(IndicatorType enmType, UIMachine *pMachine)
     : m_enmType(enmType)
     , m_pMachine(pMachine)
-    , m_pSession(pSession)
 {
     /* Install UISessionStateStatusBarIndicator accessibility interface factory: */
@@ -173,6 +169,6 @@
 
     /** Constructs indicator passing @a pMachine to the base-class. */
-    UIIndicatorHardDrive(UIMachine *pMachine, UISession *pSession)
-        : UISessionStateStatusBarIndicator(IndicatorType_HardDisks, pMachine, pSession)
+    UIIndicatorHardDrive(UIMachine *pMachine)
+        : UISessionStateStatusBarIndicator(IndicatorType_HardDisks, pMachine)
     {
         /* Assign state-icons: */
@@ -225,6 +221,6 @@
 
     /** Constructs indicator passing @a pMachine to the base-class. */
-    UIIndicatorOpticalDisks(UIMachine *pMachine, UISession *pSession)
-        : UISessionStateStatusBarIndicator(IndicatorType_OpticalDisks, pMachine, pSession)
+    UIIndicatorOpticalDisks(UIMachine *pMachine)
+        : UISessionStateStatusBarIndicator(IndicatorType_OpticalDisks, pMachine)
     {
         /* Assign state-icons: */
@@ -266,6 +262,6 @@
 
     /** Constructs indicator passing @a pMachine to the base-class. */
-    UIIndicatorFloppyDisks(UIMachine *pMachine, UISession *pSession)
-        : UISessionStateStatusBarIndicator(IndicatorType_FloppyDisks, pMachine, pSession)
+    UIIndicatorFloppyDisks(UIMachine *pMachine)
+        : UISessionStateStatusBarIndicator(IndicatorType_FloppyDisks, pMachine)
     {
         /* Assign state-icons: */
@@ -316,6 +312,6 @@
 
     /** Constructs indicator passing @a pMachine to the base-class. */
-    UIIndicatorAudio(UIMachine *pMachine, UISession *pSession)
-        : UISessionStateStatusBarIndicator(IndicatorType_Audio, pMachine, pSession)
+    UIIndicatorAudio(UIMachine *pMachine)
+        : UISessionStateStatusBarIndicator(IndicatorType_Audio, pMachine)
     {
         /* Assign state-icons: */
@@ -363,6 +359,6 @@
 
     /** Constructs indicator passing @a pMachine to the base-class. */
-    UIIndicatorNetwork(UIMachine *pMachine, UISession *pSession)
-        : UISessionStateStatusBarIndicator(IndicatorType_Network, pMachine, pSession)
+    UIIndicatorNetwork(UIMachine *pMachine)
+        : UISessionStateStatusBarIndicator(IndicatorType_Network, pMachine)
         , m_pTimerAutoUpdate(0)
     {
@@ -441,6 +437,6 @@
 
     /** Constructs indicator passing @a pMachine to the base-class. */
-    UIIndicatorUSB(UIMachine *pMachine, UISession *pSession)
-        : UISessionStateStatusBarIndicator(IndicatorType_USB, pMachine, pSession)
+    UIIndicatorUSB(UIMachine *pMachine)
+        : UISessionStateStatusBarIndicator(IndicatorType_USB, pMachine)
     {
         /* Assign state-icons: */
@@ -481,6 +477,6 @@
 
     /** Constructs indicator passing @a pMachine to the base-class. */
-    UIIndicatorSharedFolders(UIMachine *pMachine, UISession *pSession)
-        : UISessionStateStatusBarIndicator(IndicatorType_SharedFolders, pMachine, pSession)
+    UIIndicatorSharedFolders(UIMachine *pMachine)
+        : UISessionStateStatusBarIndicator(IndicatorType_SharedFolders, pMachine)
     {
         /* Assign state-icons: */
@@ -518,6 +514,6 @@
 
     /** Constructs indicator passing @a pMachine to the base-class. */
-    UIIndicatorDisplay(UIMachine *pMachine, UISession *pSession)
-        : UISessionStateStatusBarIndicator(IndicatorType_Display, pMachine, pSession)
+    UIIndicatorDisplay(UIMachine *pMachine)
+        : UISessionStateStatusBarIndicator(IndicatorType_Display, pMachine)
     {
         /* Assign state-icons: */
@@ -565,6 +561,6 @@
 
     /** Constructs indicator passing @a pMachine to the base-class. */
-    UIIndicatorRecording(UIMachine *pMachine, UISession *pSession)
-        : UISessionStateStatusBarIndicator(IndicatorType_Recording, pMachine, pSession)
+    UIIndicatorRecording(UIMachine *pMachine)
+        : UISessionStateStatusBarIndicator(IndicatorType_Recording, pMachine)
         , m_pAnimation(0)
         , m_dRotationAngle(0)
@@ -674,6 +670,6 @@
 
     /** Constructs indicator passing @a pMachine to the base-class. */
-    UIIndicatorFeatures(UIMachine *pMachine, UISession *pSession)
-        : UISessionStateStatusBarIndicator(IndicatorType_Features, pMachine, pSession)
+    UIIndicatorFeatures(UIMachine *pMachine)
+        : UISessionStateStatusBarIndicator(IndicatorType_Features, pMachine)
         , m_iCPULoadPercentage(0)
     {
@@ -781,6 +777,6 @@
 
     /** Constructor, using @a pMachine for state-update routine. */
-    UIIndicatorMouse(UIMachine *pMachine, UISession *pSession)
-        : UISessionStateStatusBarIndicator(IndicatorType_Mouse, pMachine, pSession)
+    UIIndicatorMouse(UIMachine *pMachine)
+        : UISessionStateStatusBarIndicator(IndicatorType_Mouse, pMachine)
     {
         /* Assign state-icons: */
@@ -857,6 +853,6 @@
 
     /** Constructor, using @a pMachine for state-update routine. */
-    UIIndicatorKeyboard(UIMachine *pMachine, UISession *pSession)
-        : UISessionStateStatusBarIndicator(IndicatorType_Keyboard, pMachine, pSession)
+    UIIndicatorKeyboard(UIMachine *pMachine)
+        : UISessionStateStatusBarIndicator(IndicatorType_Keyboard, pMachine)
     {
         /* Assign state-icons: */
@@ -939,9 +935,9 @@
 
 
-UIIndicatorsPool::UIIndicatorsPool(UIMachine *pMachine, UISession *pSession, QWidget *pParent /* = 0 */)
+UIIndicatorsPool::UIIndicatorsPool(UIMachine *pMachine, QWidget *pParent /* = 0 */)
     : QWidget(pParent)
     , m_pMachine(pMachine)
-    , m_pSession(pSession)
     , m_fEnabled(false)
+    , m_pMainLayout(0)
     , m_pTimerAutoUpdate(0)
 {
@@ -1182,17 +1178,17 @@
             switch (indicatorType)
             {
-                case IndicatorType_HardDisks:         m_pool[indicatorType] = new UIIndicatorHardDrive(m_pMachine, m_pSession);     break;
-                case IndicatorType_OpticalDisks:      m_pool[indicatorType] = new UIIndicatorOpticalDisks(m_pMachine, m_pSession);  break;
-                case IndicatorType_FloppyDisks:       m_pool[indicatorType] = new UIIndicatorFloppyDisks(m_pMachine, m_pSession);   break;
-                case IndicatorType_Audio:             m_pool[indicatorType] = new UIIndicatorAudio(m_pMachine, m_pSession);         break;
-                case IndicatorType_Network:           m_pool[indicatorType] = new UIIndicatorNetwork(m_pMachine, m_pSession);       break;
-                case IndicatorType_USB:               m_pool[indicatorType] = new UIIndicatorUSB(m_pMachine, m_pSession);           break;
-                case IndicatorType_SharedFolders:     m_pool[indicatorType] = new UIIndicatorSharedFolders(m_pMachine, m_pSession); break;
-                case IndicatorType_Display:           m_pool[indicatorType] = new UIIndicatorDisplay(m_pMachine, m_pSession);       break;
-                case IndicatorType_Recording:         m_pool[indicatorType] = new UIIndicatorRecording(m_pMachine, m_pSession);     break;
-                case IndicatorType_Features:          m_pool[indicatorType] = new UIIndicatorFeatures(m_pMachine, m_pSession);      break;
-                case IndicatorType_Mouse:             m_pool[indicatorType] = new UIIndicatorMouse(m_pMachine, m_pSession);         break;
-                case IndicatorType_Keyboard:          m_pool[indicatorType] = new UIIndicatorKeyboard(m_pMachine, m_pSession);      break;
-                case IndicatorType_KeyboardExtension: m_pool[indicatorType] = new UIIndicatorKeyboardExtension;                     break;
+                case IndicatorType_HardDisks:         m_pool[indicatorType] = new UIIndicatorHardDrive(m_pMachine);     break;
+                case IndicatorType_OpticalDisks:      m_pool[indicatorType] = new UIIndicatorOpticalDisks(m_pMachine);  break;
+                case IndicatorType_FloppyDisks:       m_pool[indicatorType] = new UIIndicatorFloppyDisks(m_pMachine);   break;
+                case IndicatorType_Audio:             m_pool[indicatorType] = new UIIndicatorAudio(m_pMachine);         break;
+                case IndicatorType_Network:           m_pool[indicatorType] = new UIIndicatorNetwork(m_pMachine);       break;
+                case IndicatorType_USB:               m_pool[indicatorType] = new UIIndicatorUSB(m_pMachine);           break;
+                case IndicatorType_SharedFolders:     m_pool[indicatorType] = new UIIndicatorSharedFolders(m_pMachine); break;
+                case IndicatorType_Display:           m_pool[indicatorType] = new UIIndicatorDisplay(m_pMachine);       break;
+                case IndicatorType_Recording:         m_pool[indicatorType] = new UIIndicatorRecording(m_pMachine);     break;
+                case IndicatorType_Features:          m_pool[indicatorType] = new UIIndicatorFeatures(m_pMachine);      break;
+                case IndicatorType_Mouse:             m_pool[indicatorType] = new UIIndicatorMouse(m_pMachine);         break;
+                case IndicatorType_Keyboard:          m_pool[indicatorType] = new UIIndicatorKeyboard(m_pMachine);      break;
+                case IndicatorType_KeyboardExtension: m_pool[indicatorType] = new UIIndicatorKeyboardExtension;         break;
                 default: break;
             }
Index: /trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIIndicatorsPool.h
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIIndicatorsPool.h	(revision 98490)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIIndicatorsPool.h	(revision 98491)
@@ -47,5 +47,4 @@
 class QIStatusBarIndicator;
 class UIMachine;
-class UISession;
 
 /** QWidget extension
@@ -64,10 +63,9 @@
 public:
 
-    /** Constructor, passes @a pParent to the QWidget constructor.
-      * @param  pMachine  Brings the machine UI reference.
-      * @param  pSession  Brings the session UI reference. */
-    UIIndicatorsPool(UIMachine *pMachine, UISession *pSession, QWidget *pParent = 0);
-    /** Destructor. */
-    ~UIIndicatorsPool();
+    /** Constructs indicator-pool passing @a pParent to the base-class.
+      * @param  pMachine  Brings the machine UI reference. */
+    UIIndicatorsPool(UIMachine *pMachine, QWidget *pParent = 0);
+    /** Destructs indicator-pool. */
+    virtual ~UIIndicatorsPool() RT_OVERRIDE;
 
     /** Updates appearance for passed @a indicatorType. */
@@ -123,16 +121,19 @@
     /** Holds the machine UI reference. */
     UIMachine *m_pMachine;
-    /** Holds the session UI reference. */
-    UISession *m_pSession;
+
     /** Holds whether status-bar is enabled. */
-    bool m_fEnabled;
+    bool  m_fEnabled;
+
     /** Holds the cached restrictions. */
-    QList<IndicatorType> m_restrictions;
+    QList<IndicatorType>  m_restrictions;
     /** Holds the cached order. */
-    QList<IndicatorType> m_order;
+    QList<IndicatorType>  m_order;
+
     /** Holds cached indicator instances. */
-    QMap<IndicatorType, QIStatusBarIndicator*> m_pool;
+    QMap<IndicatorType, QIStatusBarIndicator*>  m_pool;
+
     /** Holds the main-layout instance. */
     QHBoxLayout *m_pMainLayout;
+
     /** Holds the auto-update timer instance. */
     QTimer *m_pTimerAutoUpdate;
Index: /trunk/src/VBox/Frontends/VirtualBox/src/runtime/normal/UIMachineWindowNormal.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/runtime/normal/UIMachineWindowNormal.cpp	(revision 98490)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/runtime/normal/UIMachineWindowNormal.cpp	(revision 98491)
@@ -311,5 +311,5 @@
                 this, &UIMachineWindowNormal::sltHandleStatusBarContextMenuRequest);
         /* Create indicator-pool: */
-        m_pIndicatorsPool = new UIIndicatorsPool(machineLogic()->uimachine(), machineLogic()->uisession());
+        m_pIndicatorsPool = new UIIndicatorsPool(machineLogic()->uimachine());
         AssertPtrReturnVoid(m_pIndicatorsPool);
         {